#import <appkit/color.h>
#import <appkit/View.h>
#import "UserPath.h"

// you can change MAXCOUNT to anything higher if you want
#define MAXCOUNT 200

typedef double POINT[2];
typedef double VECTOR[2];

@interface SpermView : View {
    UserPath *uPath;
    POINT x[MAXCOUNT], prevX[MAXCOUNT];
    VECTOR v[MAXCOUNT];
    VECTOR mouse;
    double sine[MAXCOUNT];
    double cosine[MAXCOUNT];
    double vel[MAXCOUNT];
    double rad;
    double dir;
    NXColor color; 
    int oldEventMask;
	BOOL alreadyInitialized;
	int randCount1, randCount2;

	BOOL useColors; 
	NXCoord lineWidth;
	int count;
	id inspectorPanel;

	id spermCountSlider;
	id spermWidthSlider;
	id colorButton;
}

extern id SP_sharedInspectorPanel;
extern BOOL SP_useColors; 
extern NXCoord SP_lineWidth;
extern int SP_count;

- initFrame:(const NXRect *)rect;
- (void)initializeLine:(int)i;
- oneStep;
- drawPath;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- free;

- newWindow;

- effectOne;
- effectTwo;
- effectThree;
- effectFour;
- effectFive;
- effectSix;
- effectSeven;
- doEffectNumber:(int)val;

- setNumLines:sender;
- getSpermCount;
- setUseColor:sender;
- getUseColor;
- setLineWidth:sender;
- getLineWidth;

- inspector:sender;
@end
