#import "drawundo.h"

@interface LineWidthGraphicsChange(PrivateMethods)

- (BOOL)subsumeIdenticalChange:change;

@end

@implementation LineWidthGraphicsChange

- initGraphicView:aGraphicView lineWidth:(float)aWidth
{
    [super initGraphicView:aGraphicView];
    widthValue = aWidth;
    return self;
}

- (const char *)changeName
{
    return NXLocalStringFromTable("Operations", "Line Width", NULL, "The operation of changing the width of a line segment.");
}

- changeDetailClass
{
    return [LineWidthChangeDetail class];
}

- (float)lineWidth
{
    return widthValue;
}

- (BOOL)subsumeIdenticalChange:change
{
    widthValue = [(LineWidthGraphicsChange *)change lineWidth];
    return YES;
}

@end
