
#import <objc/Object.h>
@class Window, Expression, N3DCamera, FormCell, Matrix, Slider, SliderCell, TextFieldCell, Button, NXDataLinkManager;

@interface Graph3DDoc : Object {
    Window *window;
    Expression *expr[3];	/* Expression objects for evaluation */
    N3DCamera *camera;		/* camera for drawing graph */
    FormCell *equation[3];	/* forms holding equation text */
    Matrix *variableSliders;	/* outlets to other controls */
    Matrix *variableTexts;
    Matrix *variableLabels;
    Matrix *variableMinLabels;
    Matrix *variableMaxLabels;
    SliderCell *resolutionSlider;
    TextFieldCell *resolutionText;
    SliderCell *minUVSlider[2];
    TextFieldCell *minUVText[2];
    SliderCell *maxUVSlider[2];
    TextFieldCell *maxUVText[2];
    char *name;			/* the name of the document */
    char *realName;		/* unambiguous name of the document */
    NXDataLinkManager *linkMgr;
    List *linksTracked;		/* active links to this document */
}

- init;
- initFromFile:(const char *)file;
- free;
- (const char *)filename;
/* unambiguous path to this file (no symlinks) */
- (const char *)realFilename;

/* target action messages sent from various graph controls */
- equationChanged:sender;
- uRangeSliderChanged:sender;
- uRangeTextChanged:sender;
- vRangeSliderChanged:sender;
- vRangeTextChanged:sender;
- resolutionChanged:sender;
- variableSliderChanged:sender;
- variableTextChanged:sender;

/* target action messages sent menu items */
- copyGraph:sender;
- save:sender;
- saveAs:sender;
- saveTo:sender;

/* allows views in the window to notify us when the doc is edited */
- docChanged;

@end
