/* Copyright (c) 1992, 1993 NeXT Computer, Inc.  All rights reserved. 
 *
 * ATI.h - Definition of the ATi display driver class.
 *
 * HISTORY
 * 12 Oct 92	Joe Pasqua
 *      Created. 
* 01 June 93	Mike Paquette
 *	Rewrite: Convert from Corsair device driver to general MACH32 chipset
 * 		driver.
 *  7 July 1993	Derek B Clegg
 *	Cleaned up for external release.
 */
#ifndef ATI_H__
#define ATI_H__

#import <driverkit/IOFrameBufferDisplay.h>
#import "ATIModes.h"

@interface ATI:IOFrameBufferDisplay
{
    /* The flavor of ATI chipset which we have. */
    ATIFlavor ati_flavor;

    /* Setup parameters. */
    const ATI_CRTCSetup *CRTControllerSetup;

    /* The information for the selected display mode. */
    const IODisplayInfo *displayMode;

    /* The transfer tables for this mode. */
    unsigned int *transferTable;

    /* The number of entries in the transfer table. */
    int transferTableCount;

    /* The current screen brightness. */
    int brightnessLevel;

    unsigned int _ATI_reserved[8];
}
- (void)enterLinearMode;
- (void)revertToVGAMode;
- initFromDeviceDescription: deviceDescription;
- setTransferTable:(const unsigned int *)table count:(int)count;
@end

#endif	/* ATI_H__ */
